---
layout: layouts/exercise_base.njk
exercise: 1
points: 5
---
{# Python
import bitstring
bitstring.Bits(bin='11101110').int
bitstring.Bits(int=-18, length=8).bin
#}
<ol>
  <li><strong>Decimal $\rightarrow$ Two's Complement</strong><br />
    Convert the following decimal numbers to 8-bit two's complement.
    <ol>
      <li>123</li>{# 01111011 #}
      <li>-18</li>{# 11101110 #}
      <li>-1</li>{# 11111111 #}
      <li>99</li>{# 01100011 #}
      <li>-128</li>{# 1000000 #}
    </ol>
  </li>
  <li>
    <strong>Two's Complement $\rightarrow$ Decimal</strong><br />
    <ol>
      <li><kbd>11111010</kbd></li>{# -6 #}
      <li><kbd>01111110</kbd></li>{# 126 #}
      <li><kbd>11011010</kbd></li>{# -38 #}
      <li><kbd>10000011</kbd></li>{# -125 #}
      <li><kbd>00000011</kbd></li>{# 3 #}
    </ol>
  </li>
  <li>
    <strong>Addition</strong><br />
    Perform the following calculations with 8 bit two's complement binary numbers.
    Convert the result back to decimal to see if your calculation was correct.
    <ol>
      <li><kbd>27 - 6</kbd></li>
      <li><kbd>127 - 128</kbd></li>
      <li><kbd>32 - 100</kbd></li>
      <li><kbd>61 - 61</kbd></li>
      <li><kbd>-99 + 12</kbd></li>
    </ol>
  </li>
</ol>
